# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_with native
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/antlr/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define with_mono %{?_with_mono:1}%{!?_with_mono:%{?rhel:0}%{!?rhel:1}}

%define build_jedit  %{?_with_jedit:1}%{!?_with_jedit:0}

%define section free
%define native  %{?_with_native:1}%{!?_with_native:0}

%global debug_package %{nil}

%global meadversion %{version}-redhat-1

Summary:        ANother Tool for Language Recognition
Name:           antlr
Version:        2.7.7
Release:        10_redhat_1%{?dist}.2
Epoch:          0
License:        Public Domain
URL:            http://www.antlr.org/
Group:          Development/Code Generators
Source0:        http://www.antlr2.org/download/antlr-%{version}.tar.gz
Source1:        %{name}-build.xml
Source2:        %{name}-script
#http://www.antlr.org/share/1069557132934/makefile.gcj
Source3:        makefile.gcj
Source4:        antlr-component-info.xml
#Source5:        http://repo2.maven.org/maven2/antlr/antlr/2.7.7/antlr-2.7.7.pom
Source5:        antlr-2.7.7-vman.pom
Patch0:         %{name}-jedit.patch
Patch1:         %{name}-%{version}-newgcc.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if %with native
BuildRequires:  %{_bindir}/gcj, %{__make}
%else
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRequires:  ant
BuildRequires:  maven2-plugin-deploy

%if 0%{?with_mono}
%ifnarch s390 s390x ppc64 sparc64
BuildRequires:  mono-core
BuildRequires:  mono-winforms
%endif
%endif

BuildRequires:  %{__perl}, java-javadoc
BuildRequires:  jboss-parent
BuildRequires:  maven-buildmagic-thirdparty-plugin
Requires:       jpackage-utils
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package        native
Group:          Development/Code Generators
Summary:        ANother Tool for Language Recognition (native version)
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%description    native
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].  This package includes the native version of the antlr tool.

%package        manual
Group:          Development/Code Generators
Summary:        Manual for %{name}

%description    manual
Documentation for %{name}.

%package        javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description    javadoc
Javadoc for %{name}.

%if %{build_jedit}
%package        jedit
Group:          Text Editors
Summary:        ANTLR mode for jEdit
Requires:       jedit >= 0:4.1

%description    jedit
ANTLR mode for jEdit.  To enable this mode, insert the following into your
%{_datadir}/jedit/modes/catalog:

  <MODE NAME="antlr" FILE="antlr.xml" FILE_NAME_GLOB="*.g"/>
%endif

%prep
%setup -q
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
%if %without native
%patch0 -p0
cp -p %{SOURCE1} build.xml
# fixup paths to manual
%{__perl} -pi -e 's|"doc/|"%{_docdir}/%{name}-manual-%{version}/|g' \
  install.html
%endif
%{__perl} -pi -e 's/\r$//' LICENSE.txt
%patch1

%build
%if %with native
%{__make} -f %{SOURCE3} COMPOPTS="%{optflags}"

%else
ant -Dj2se.apidoc=%{_javadocdir}/java
cp work/lib/antlr.jar .  # make expects to find it here
export CLASSPATH=.
%configure --without-examples
make CXXFLAGS="${CXXFLAGS} -fPIC"

find . -type f > /tmp/antlr.filelist
rm antlr.jar             # no longer needed
%endif

%install
rm -rf %{buildroot}

install -dm 755 %{buildroot}%{_bindir}
touch %{buildroot}%{_bindir}/antlr # for %%ghost

%if %with native

install -pm 755 cantlr %{buildroot}%{_bindir}/antlr-native

%else
# jars
mkdir -p %{buildroot}%{_javadir}
cp -p work/lib/%{name}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{SOURCE5} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap antlr antlr %{version} JPP %{name}

# script
cp -p %{SOURCE2} %{buildroot}%{_bindir}/antlr-java

# C++ lib and headers, antlr-config
%define headers %{_includedir}/%{name}

mkdir -p $RPM_BUILD_ROOT{%{headers},%{_libdir}}
install -m 644 lib/cpp/antlr/*.hpp $RPM_BUILD_ROOT%{headers}
install -m 644 lib/cpp/src/libantlr.a $RPM_BUILD_ROOT%{_libdir}
install -m 755 scripts/antlr-config $RPM_BUILD_ROOT%{_bindir}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr work/api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# jedit mode
%if %{build_jedit}
mkdir -p %{buildroot}%{_datadir}/jedit/modes
cp -p extras/antlr-jedit.xml %{buildroot}%{_datadir}/jedit/modes/antlr.xml
%endif
%endif

# manual
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}/
cp -pr doc/* %{buildroot}%{_docdir}/%{name}-%{version}/

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE4} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/antlr.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/antlr.pom
# maven2-brew
install -d -m 755 %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
pushd $RPM_BUILD_ROOT%{repodir}

mvn-jpp -e \
    deploy:deploy-file \
    -Dversion=%{meadversion} \
    -DpomFile=%{buildroot}%{repodirlib}/antlr.pom \
    -Dfile=%{buildroot}%{repodirlib}/antlr.jar \
    -Durl=file://%{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/ \


popd

#FIXME for some reason any deploy operation puts the pom inside a 2.7.7 dir
pushd %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/antlr/antlr
ls -l
mv 2.7.7/* %{meadversion}/
rm -Rf %{version}
popd

%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_bindir}/antlr \
  %{name} %{_bindir}/antlr-java 10
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif
%update_maven_depmap

%postun
if [ $1 -eq 0 ] ; then
  %{_sbindir}/update-alternatives --remove %{name} %{_bindir}/antlr-java
fi

%update_maven_depmap
%if %with native
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post native
%{_sbindir}/update-alternatives --install %{_bindir}/antlr \
  %{name} %{_bindir}/antlr-native 20

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun native
if [ $1 -eq 0 ] ; then
  %{_sbindir}/update-alternatives --remove %{name} %{_bindir}/antlr-native
fi
%endif

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %with native
%files native
%defattr(0644,root,root,0755)
%doc INSTALL.txt LICENSE.txt
%defattr(0755,root,root,0755)
%ghost %{_bindir}/antlr
%{_bindir}/antlr-native

%else
%files
%defattr(0644,root,root,0755)
%doc INSTALL.txt LICENSE.txt
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{headers}
%{_libdir}/libantlr.a
%defattr(0755,root,root,0755)
%ghost %{_bindir}/antlr
%{_bindir}/antlr-config
%{_bindir}/antlr-java
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %{build_jedit}
%files jedit
%defattr(0644,root,root,0755)
%{_datadir}/jedit/modes/*
%endif
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Mar 27 2012 Yong Yang <yyang@redhat.com> - 0:2.7.7-10_redhat_1.2
- Fix pom location in -repolib

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.7.7-10_redhat_1.1
- Rebuild using cache signing

* Mon Feb 06 2012 Yong Yang <yyang@redhat.com> - 0:2.7.7-10_redhat_1
- Fix pom location in -repolib

* Fri Feb 03 2012 Yong Yang <yyang@redhat.com> - 0:2.7.7-9_redhat_1
- Latest vman, resign

* Mon Aug 29 2011 Yong Yang <yyang@redhat.com> - 0:2.7.7-8_redhat_1
- Build for werewolf

* Wed Mar 23 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-7
- Merge from RHEL6

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.4
- Rebuild

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.3
- Rebuild

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.2
- Rebuild

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.1
- Add maven2-brew contents to repolib

* Mon Feb 28 2011 David Walluck <dwalluck@redhat.com> 0:2.7.7-1
- 2.7.7

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 0:2.7.6-8
- Auto rebuild for JPackage 6 in centos5 mock

* Mon Nov 02 2009 David Walluck <dwalluck@redhat.com> 0:2.7.6-7
- add maven support

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:2.7.6-6
- fix repolib
- fix location of manual
- fix LICENSE.txt eol
- fix macro-in-%%changelog

* Thu Jul 31 2008 David Walluck <dwalluck@redhat.com> 0:2.7.6-5
- fix Release
- update BuildRoot
- remove javadoc scriptlets
- GCJ fixes
- fix permissions
- fix repolib permissions

* Tue May 27 2008 Permaine Cheung <pcheung@redhat.com> - 0:2.7.6-4jpp
- First JPP5 build

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.7.6-3jpp.ep1.2
- Fix typo in repodir

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-3jpp.ep1.1
- New repolib location

* Mon Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.7.6-3jpp.el4ep1.2
- Use -brew suffix

* Thu Feb 15 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.7.6-3jpp.el4ep1.1
- Repolib support added

* Wed Aug 02 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-3jpp_1rh
- Merge with upstream

* Wed Jul 19 2006 Deepak Bhole <dbhole@redhat.om> = 0:2.7.6-3jpp
- Added conditional native compilation.

* Fri Jan 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-2jpp_1rh
- Merge with upstream for upgrade

* Fri Jan 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-2jpp
- First JPP 1.7 build

* Fri Jan 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-1jpp
- Update to 2.7.6.

* Mon Nov 15 2004 Fernando Nasser <fnasser@redhat.com> - 0:2.7.4-2jpp_1rh
- Merge with upstream for upgrade

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.7.4-2jpp
- Build with ant-1.6.2.
- Made native scripts conditional

* Tue May 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.4-1jpp
- Update to 2.7.4.

* Fri Apr  2 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.3-2jpp
- Create alternatives also on upgrades.

* Wed Mar 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.3-1jpp
- Update to 2.7.3.
- Include gcj build option and a native subpackage, build using
  "--with native" to get that.
- Add %%{_bindir}/antlr alternative.

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com - 0:2.7.2-3jpp_1rh
- RH vacuuming

* Mon Dec 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.2-3jpp
- Add non-versioned javadoc dir symlink.
- Crosslink with local J2SE javadocs.
- Spec cleanups, change to UTF-8.

* Sun Mar 30 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.2-2jpp
- Rebuild for JPackage 1.5.

* Sat Mar  1 2003 Ville Skyttä <ville.skytta at iki.fi> - 2.7.2-1jpp
- Update to 2.7.2.
- Include antlr script and jEdit mode (see antlr-jedit RPM description).
- Use sed instead of bash 2 extension when symlinking jars during build.

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-8jpp
- really section macro
- hardcoded distribution and vendor tag
- group tag again

* Thu May 2 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-7jpp
- distribution tag
- group tag
- section macro

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-6jpp
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- additional sources in individual archives

* Sat Dec 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-5jpp
- javadoc in javadoc package

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 2.7.1-4jpp
- removed packager tag
- new jpp extension

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-3jpp
- used a build file instead of makefile
- build classes instead of blindly jared them !
- used original tarball
- corrected license spelling

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-2jpp
- first unified release
- s/jPackage/JPackage

* Tue Aug 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-1mdk
- first Mandrake release
